import { add_to_version_info as $2gSyd$add_to_version_info, catchify as $2gSyd$catchify, href_change_ipns as $2gSyd$href_change_ipns, snakeCasifyObject as $2gSyd$snakeCasifyObject, observer as $2gSyd$observer } from "@depict-ai/utilishared/latest";
import { fetchDepictRecommendations as $81cb049e9a47a255$re_export$fetchDepictRecommendations, ClassicSearchModal as $81cb049e9a47a255$re_export$ClassicSearchModal, SearchModalV2 as $81cb049e9a47a255$re_export$SearchModalV2, embedded_num_products as $81cb049e9a47a255$re_export$EmbeddedNumProducts, CategoryTitle as $81cb049e9a47a255$re_export$CategoryTitle, DepictAPI as $2gSyd$DepictAPI, DepictCategory as $2gSyd$DepictCategory, open_modal_with_alignment as $2gSyd$open_modal_with_alignment, modalVersionSymbol as $2gSyd$modalVersionSymbol, DepictSearch as $2gSyd$DepictSearch, SearchPage as $2gSyd$SearchPage, defaultColsAtSize as $2gSyd$defaultColsAtSize, defaultGridSpacing as $2gSyd$defaultGridSpacing, SearchField as $2gSyd$SearchField, CategoryPage as $2gSyd$CategoryPage, PageReplacer as $2gSyd$PageReplacer, RecommendationSlider as $2gSyd$RecommendationSlider, RecommendationGrid as $2gSyd$RecommendationGrid, LooksSliderOrGrid as $2gSyd$LooksSliderOrGrid, TextPlaceholder as $2gSyd$TextPlaceholder, ImagePlaceholder as $2gSyd$ImagePlaceholder, BreadCrumbs as $2gSyd$BreadCrumbs, QuickLinks as $2gSyd$QuickLinks } from "@depict-ai/ui/latest";
import { DPC as $81cb049e9a47a255$re_export$DPC } from "@depict-ai/dpc/latest";
import { createSignal as $2gSyd$createSignal } from "solid-js";
import { register_es_version } from "../multi_import_deduplicator.mjs";
register_es_version("js-ui", "latest");
const $1516fe26a560ed78$export$83d89fbfd8236492 = "4.10.5";

// A workaround system for completely hiding our @depict-ai/ui internals in wrapped components,
// while still allowing the wrapped components to expose the internals to each other. Each wrapped component is responsible for creating
// the internal instance and storing it in this WeakMap, then other wrapped components can access the internals related to another wrapped component.
const $929b0b0fcbbd865e$export$981972f5b84bc3cb = /*@__PURE__*/new WeakMap();
const $929b0b0fcbbd865e$export$cad8b33069faf956 = /*@__PURE__*/new WeakMap();
class $9bbcaf6bc113bb21$export$5d13af1f32ae532e {
  #category;
  #listing_query_state_key;
  get listingQuery() {
    return this.#category.listing_query;
  }
  set listingQuery(query) {
    // When they set a category id, save it in the state, so we can restore it on back/forward
    const old_state = history.state;
    if (old_state[this.#listing_query_state_key] !== query) history.replaceState({
      ...old_state,
      [this.#listing_query_state_key]: query
    }, "", location.href);
    this.#category.listing_query = query;
  }
  get disableOverrideListingId() {
    return this.#category.disable_override_listing_id;
  }
  set disableOverrideListingId(disable) {
    this.#category.disable_override_listing_id = disable;
  }
  // Todo: Expose changing merchant and market etc, same as react-ui.
  constructor(options) {
    const {
      market: market,
      merchant: merchant,
      sessionId: sessionId,
      metaData: metaData,
      locale: locale,
      listingQuery: listingQuery,
      disableOverrideListingId: disableOverrideListingId,
      displayTransformers: displayTransformers,
      uniqueInstanceKeyForState = ""
    } = options;
    const api = new (0, $2gSyd$DepictAPI)({
      get_metadata: async () => metaData,
      get_session_id: () => sessionId,
      // @ts-ignore
      display_transformers: displayTransformers
    });
    this.#listing_query_state_key = `category${uniqueInstanceKeyForState}_current_listing_query`;
    this.#category = new (0, $2gSyd$DepictCategory)({
      api: api,
      market: market,
      merchant: merchant,
      localization: locale,
      unique_instance_key_for_state: uniqueInstanceKeyForState,
      listing_query_state_key: this.#listing_query_state_key
    });
    this.listingQuery = listingQuery; // Here we need to call the setter on `this`, because we want to update the state so that when ppl go back to the initial page, they get the right category
    if (typeof disableOverrideListingId === "boolean") this.#category.disable_override_listing_id = disableOverrideListingId;
    (0, $929b0b0fcbbd865e$export$cad8b33069faf956).set(this, this.#category);
    $2gSyd$catchify(async () => {
      for await (const _ of (0, $2gSyd$href_change_ipns)) {
        // If someone pushes a new page with a new id, or we go back/forward, update the category id
        const query_in_state = history.state[this.#listing_query_state_key];
        if (query_in_state && (query_in_state.id !== this.listingQuery.id || query_in_state.type !== this.listingQuery.type))
          // Don't actually call the setter on (this), because we don't want to update the state
          this.#category.listing_query = query_in_state;
      }
    })();
  }
}
class $51b99f60d4819438$export$9aa84a6b7bde7bae {
  #search;
  #modalVersion;
  openModal(alignerElement) {
    const runAnimations_ = this.#modalVersion === 2;
    if (alignerElement) $2gSyd$open_modal_with_alignment({
      location: "aligned",
      element: alignerElement,
      search: this.#search,
      runAnimations_: runAnimations_
    });else $2gSyd$open_modal_with_alignment({
      location: "centered",
      search: this.#search,
      runAnimations_: runAnimations_
    });
  }
  fetchSearchResults(query, filters, maxResults) {
    return this.#search.fetchSearchResults(query, filters, maxResults);
  }
  // Todo: Expose changing merchant and market etc, same as react-ui.
  constructor(options) {
    const {
      market: market,
      merchant: merchant,
      sessionId: sessionId,
      metaData: metaData,
      locale: locale,
      urlParamName: urlParamName,
      enableCategorySuggestions: enableCategorySuggestions,
      enableContentSearch: enableContentSearch,
      searchPagePath: searchPagePath,
      displayTransformers: displayTransformers,
      searchModalComponent: searchModalComponent
    } = options;
    const api = new (0, $2gSyd$DepictAPI)({
      get_metadata: async () => metaData,
      get_session_id: () => sessionId,
      // @ts-ignore
      display_transformers: displayTransformers
    });
    const modalComponentToUse = searchModalComponent || (process.env.NO_SEARCH_MODAL_DEFAULT === "true" ? undefined : (0, $81cb049e9a47a255$re_export$SearchModalV2));
    this.#modalVersion = modalComponentToUse[(0, $2gSyd$modalVersionSymbol)];
    this.#search = new (0, $2gSyd$DepictSearch)({
      api: api,
      market: market,
      merchant: merchant,
      search_query_url_param_name: urlParamName,
      enable_category_suggestions: enableCategorySuggestions ?? false,
      // default false
      url_transformer: url => url.pathname = searchPagePath,
      localization: locale,
      unique_instance_key_for_state: options.uniqueInstanceKeyForState,
      enable_content_search: enableContentSearch,
      searchModalComponent: modalComponentToUse
    });
    (0, $929b0b0fcbbd865e$export$981972f5b84bc3cb).set(this, this.#search);
  }
}
function $f9381dbe50b99266$export$a54ec244c8863715({
  searchProvider: searchProvider,
  includeInputField: includeInputField,
  gridSpacing: gridSpacing,
  columnsAtSize: columnsAtSize,
  productCard: productCard,
  onQueryChange: onQueryChange,
  getContentBlocksByRow: getContentBlocksByRow
}) {
  // Todo: get rid of wrapper div by making Searchpage just export one element. Comments can go inside that element.
  const div = document.createElement("div");
  div.append(...$2gSyd$SearchPage({
    depict_search: (0, $929b0b0fcbbd865e$export$981972f5b84bc3cb).get(searchProvider),
    include_input_field: includeInputField,
    cols_at_size: columnsAtSize ?? (0, $2gSyd$defaultColsAtSize),
    grid_spacing: gridSpacing ?? (0, $2gSyd$defaultGridSpacing),
    product_card_template: productCard,
    on_query_change: onQueryChange,
    get content_blocks_by_row() {
      const value = getContentBlocksByRow?.();
      if (!value) return value;
      return value.map(block => block && $2gSyd$snakeCasifyObject(block));
    }
  }));
  return div;
}
function $5e5d4ebfcd7e2bfa$export$b94867ecbd698f21({
  searchProvider: searchProvider,
  alignerRef: alignerRef
}) {
  // Todo: get rid of wrapper div by making SearchField just export one element. Comments can go inside that element.
  return $2gSyd$SearchField({
    depict_search: (0, $929b0b0fcbbd865e$export$981972f5b84bc3cb).get(searchProvider),
    aligner_ref: alignerRef
  })[0];
}
function $3cec0b61ec0636f4$export$f7d2f673fc2f091d({
  gridSpacing: gridSpacing,
  columnsAtSize: columnsAtSize,
  productCard: productCard,
  categoryProvider: categoryProvider,
  showBreadcrumbs: showBreadcrumbs,
  showQuicklinks: showQuicklinks,
  categoryTitlePlugin: categoryTitlePlugin,
  onListingQueryChange: onListingQueryChange,
  getContentBlocksByRow: getContentBlocksByRow,
  layout: layout
}) {
  // Todo: get rid of wrapper div by making CategoryPage just export one element. Comments can go inside that element.
  const div = document.createElement("div");
  div.append(...$2gSyd$CategoryPage({
    depict_category: (0, $929b0b0fcbbd865e$export$cad8b33069faf956).get(categoryProvider),
    show_breadcrumbs: showBreadcrumbs,
    show_quicklinks: showQuicklinks,
    cols_at_size: columnsAtSize ?? (0, $2gSyd$defaultColsAtSize),
    grid_spacing: gridSpacing ?? (0, $2gSyd$defaultGridSpacing),
    category_title: categoryTitlePlugin || (0, $81cb049e9a47a255$re_export$CategoryTitle),
    product_card_template: productCard,
    layout: layout,
    on_listing_query_change: onListingQueryChange,
    get content_blocks_by_row() {
      const value = getContentBlocksByRow?.();
      if (!value) return value;
      return value.map(block => block && $2gSyd$snakeCasifyObject(block));
    }
  }));
  return div;
}
function $ed7a961d3d8d3454$export$64e18aecaa12222c({
  isPageToReplace: isPageToReplace,
  selectorToReplace: selectorToReplace,
  renderContent: renderContent,
  renderMode = "replace",
  documentTitle: documentTitle
}) {
  let replacer = new (0, $2gSyd$PageReplacer)({
    is_page_: isPageToReplace,
    selector_: selectorToReplace,
    // Todo: Most optimized way to do this
    render_: () => {
      const content = renderContent();
      return Array.isArray(content) ? content : [content];
    },
    append_instead_of_replace_: renderMode === "append",
    title_: documentTitle
  });
  return () => {
    replacer?.destroy_();
    replacer = null;
  };
}
function $88d12cc39f46ad4f$export$82cfdc85a4d15688({
  recommendations: recommendations,
  productCard: productCard,
  columnsAtSize: columnsAtSize,
  gridSpacing: gridSpacing,
  title: title
}) {
  return $2gSyd$RecommendationSlider({
    recommendations: recommendations,
    product_card_template: productCard,
    grid_spacing: gridSpacing ?? (0, $2gSyd$defaultGridSpacing),
    cols_at_size: columnsAtSize || (0, $2gSyd$defaultColsAtSize),
    title: title
  });
}
function $0cb9c80d3dec1952$export$b0a773486c1c2312({
  recommendations: recommendations,
  productCard: productCard,
  columnsAtSize: columnsAtSize,
  gridSpacing: gridSpacing,
  viewMoreButton: viewMoreButton,
  maxRows: maxRows,
  title: title
}) {
  return $2gSyd$RecommendationGrid({
    recommendations: recommendations,
    max_rows: maxRows,
    product_card_template: productCard,
    cols_at_size: columnsAtSize || (0, $2gSyd$defaultColsAtSize),
    grid_spacing: gridSpacing ?? (0, $2gSyd$defaultGridSpacing),
    title: title,
    view_more_button: viewMoreButton ? {
      text: viewMoreButton.text,
      start_rows: viewMoreButton.startRows ?? 2,
      rows_per_click: viewMoreButton.rowsPerClick
    } : undefined
  });
}
function $ffab9a5d493b4333$export$ee471bde82ce7cf7({
  gridSpacing: gridSpacing,
  gridOptions: gridOptions,
  market: market,
  merchant: merchant,
  priceFormatting: priceFormatting,
  backendLocale: backendLocale,
  title: title,
  productId: productId,
  columnsAtSize: columnsAtSize,
  imagePlaceholderAspectRatio = 0.75,
  displayTransformers: displayTransformers,
  class: classValue
}) {
  const viewMoreButton = gridOptions?.viewMoreButton;
  return $2gSyd$LooksSliderOrGrid({
    gridSpacing_: gridSpacing ?? (0, $2gSyd$defaultGridSpacing),
    locale_: backendLocale,
    title_: title,
    market_: market,
    merchant_: merchant,
    displayTransformers_: displayTransformers,
    priceFormatting_: priceFormatting,
    imagePlaceholderAspectRatio_: imagePlaceholderAspectRatio,
    columnsAtSize_: columnsAtSize ?? (0, $2gSyd$defaultColsAtSize),
    productId_: productId,
    class_: classValue,
    gridOptions_: gridOptions && {
      max_rows: gridOptions.maxRows,
      view_more_button: viewMoreButton && {
        start_rows: viewMoreButton.startRows,
        rows_per_click: viewMoreButton.rowsPerClick,
        text: viewMoreButton.text
      }
    }
  });
}
function $ee9933cd383899da$export$89c6019e4baa40b1(options) {
  return $2gSyd$TextPlaceholder(options);
}
function $ee9933cd383899da$export$3f37af283f8fb843(options) {
  return $2gSyd$ImagePlaceholder(options);
}
function $81b88ac1c56da523$export$8ce789ad03abeef6(initialValue = []) {
  const [blocks, setContentBlocksByRow] = $2gSyd$createSignal(initialValue, {
    equals: false
  });
  return {
    getContentBlocksByRow: blocks,
    setContentBlocksByRow: setContentBlocksByRow
  };
}
function $779f32dcbe08c1d2$export$7278f0e6b349961b(selector, callback) {
  const onExistsObserver = (0, $2gSyd$observer).onexists(selector, ({
    element: element,
    disconnector: disconnector
  }) => {
    callback(element, disconnector);
  });
  return {
    disconnect: onExistsObserver
  };
}
function $0ac52df9c121609e$export$5646050d516e06bc({
  categoryProvider: categoryProvider
}) {
  return $2gSyd$BreadCrumbs({
    depict_category: (0, $929b0b0fcbbd865e$export$cad8b33069faf956).get(categoryProvider)
  });
}
function $0ac52df9c121609e$export$466cdc317043f6cb({
  categoryProvider: categoryProvider
}) {
  return $2gSyd$QuickLinks({
    depict_category: (0, $929b0b0fcbbd865e$export$cad8b33069faf956).get(categoryProvider)
  });
}
$2gSyd$add_to_version_info("js-ui", (0, $1516fe26a560ed78$export$83d89fbfd8236492));
export { $9bbcaf6bc113bb21$export$5d13af1f32ae532e as DepictCategoryProvider, $51b99f60d4819438$export$9aa84a6b7bde7bae as DepictSearchProvider, $f9381dbe50b99266$export$a54ec244c8863715 as SearchPage, $5e5d4ebfcd7e2bfa$export$b94867ecbd698f21 as SearchField, $3cec0b61ec0636f4$export$f7d2f673fc2f091d as CategoryPage, $ed7a961d3d8d3454$export$64e18aecaa12222c as SetupPageReplacer, $81cb049e9a47a255$re_export$fetchDepictRecommendations as fetchDepictRecommendations, $81cb049e9a47a255$re_export$ClassicSearchModal as ClassicSearchModal, $81cb049e9a47a255$re_export$SearchModalV2 as SearchModalV2, $88d12cc39f46ad4f$export$82cfdc85a4d15688 as RecommendationSlider, $0cb9c80d3dec1952$export$b0a773486c1c2312 as RecommendationGrid, $ffab9a5d493b4333$export$ee471bde82ce7cf7 as LooksSliderOrGrid, $ee9933cd383899da$export$89c6019e4baa40b1 as TextPlaceholder, $ee9933cd383899da$export$3f37af283f8fb843 as ImagePlaceholder, $81b88ac1c56da523$export$8ce789ad03abeef6 as contentBlockStore, $779f32dcbe08c1d2$export$7278f0e6b349961b as onExistsObserver, $0ac52df9c121609e$export$5646050d516e06bc as BreadCrumbs, $0ac52df9c121609e$export$466cdc317043f6cb as QuickLinks, $81cb049e9a47a255$re_export$EmbeddedNumProducts as EmbeddedNumProducts, $81cb049e9a47a255$re_export$CategoryTitle as CategoryTitle, $81cb049e9a47a255$re_export$DPC as DPC, $1516fe26a560ed78$export$83d89fbfd8236492 as version };